; An example CP/M application

Zeus_cpm_drives         = "cpm_disks.bin"               ; Tell Zeus where the CP/M virtual disks are stored

                        zeusemulate "cpm"               ; Tell Zeus and the emulator what to emulate
                        profile=true                    ; Allow profiling if anyone's interested.

; We'll start executing at zero, so fire up CP/M Start here

                        org $0000                       ; Z80 reset vector

                        di                              ; Disable Interrupts
                        jp RawCPMBoot                   ; Start CP/M

; This jump is the CP/M API entry point, we include it in the source so Zeus will show it when single-stepping
                        org 5                           ;
CPM_CMD                 jp FBASE                        ; The CP/M command entry point

; Build the CP/M application here.

                        org $100                        ; CP/M applications normally start at $100

AppStart                ld de,sHello                    ; Show this
                        ld c,9                          ; Output string
                        call CPM_CMD                    ; Call CP/M

                        ld c,0                          ; Exit
                        jp CPM_CMD                      ; Call CP/M

        ; The string to display

sHello                  db "Hello world!\r\n$"          ; A string

AppEnd                  equ *                           ; We'll need to know how long the application is.

; Save this application as a CP/M file

                        output_cpm "A:H.COM",AppStart,AppEnd-AppStart

; Now, we'll also include and build the CP/M source files while we're at it, so they can be single-stepped

                        include "cpm22.asm"             ;
                        include "cbios.asm"             ;

; The rest of this source is just showing some possible setting options.

; Setup the CP/M terminal colours

                        zeussyntaxhighlight 300,$00,$20,$00             ; Normal background
                        zeussyntaxhighlight 301,$00,$FF,$00             ; Normal foreground
                        zeussyntaxhighlight 302,$00,$00,$80             ; Highlight background
                        zeussyntaxhighlight 303,$FF,$FF,$FF             ; Highlight foreground

; These will show some extra memory display panels, which are set to disappear whenever the emulator page is left.
; Uncomment the following line to have them displayed, then drag/resise them to suit your display
; This is just to give an idea what you can do with memory panels.

;bShowTheMemoryPanels    equ true                        ;

        if enabled bShowTheMemoryPanels
                        zeusmem $0000,"CP/M - vars",16,true,true,true   ; Show the CP/M variable area, with address and characters and hide when editing
                        zeusmem $0100,"CP/M - TPA",16,true,true,true    ; Show the TPA, with address and characters and hide when editing
                        zeusmem $0100,"CP/M - 64 chars wide",64,true,false,true   ; Show a wide view of memory, with address but no characters and hide when editing
        endif

